Package org.optaplanner.core.impl.score.director.drools

## Class DroolsScoreDirector<Solution_>

- java.lang.Object
- - org.optaplanner.core.impl.score.director.AbstractScoreDirector<Solution_,​DroolsScoreDirectorFactory<Solution_>>
  - - org.optaplanner.core.impl.score.director.drools.DroolsScoreDirector<Solution_>

- Type Parameters:
    `Solution_` - the solution type, the class with the `PlanningSolution` annotation
  All Implemented Interfaces:
    `AutoCloseable`, `Cloneable`, `InnerScoreDirector<Solution_>`, `ScoreDirector<Solution_>`
  Direct Known Subclasses:
    `TestGenDroolsScoreDirector`

      public class DroolsScoreDirector<Solution_>
      extends AbstractScoreDirector<Solution_,​DroolsScoreDirectorFactory<Solution_>>

  Drools implementation of `ScoreDirector`, which directs the Rule Engine to calculate the `Score` of the `working solution`.
  See Also:
    `ScoreDirector`

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static String` | `GLOBAL_SCORE_HOLDER_KEY` |
    `protected org.kie.api.runtime.KieSession` | `kieSession` |
    `protected ScoreHolder` | `scoreHolder` |

    - ### Fields inherited from class org.optaplanner.core.impl.score.director.AbstractScoreDirector

      `allChangesWillBeUndoneBeforeStepEnds, calculationCount, constraintMatchEnabledPreference, logger, lookUpEnabled, lookUpManager, scoreDirectorFactory, variableListenerSupport, workingEntityListRevision, workingInitScore, workingSolution`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DroolsScoreDirector​(DroolsScoreDirectorFactory<Solution_> scoreDirectorFactory, boolean lookUpEnabled, boolean constraintMatchEnabledPreference)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `afterEntityAdded​(EntityDescriptor<Solution_> entityDescriptor, Object entity)` |
    `void` | `afterEntityRemoved​(EntityDescriptor<Solution_> entityDescriptor, Object entity)` |
    `void` | `afterProblemFactAdded​(Object problemFact)` |
    `void` | `afterProblemFactRemoved​(Object problemFact)` |
    `void` | `afterProblemPropertyChanged​(Object problemFactOrEntity)` |
    `void` | `afterVariableChanged​(VariableDescriptor variableDescriptor, Object entity)` |
    `Score` | `calculateScore()` | Calculates the `Score` and updates the `working solution` accordingly.
    `void` | `close()` | Needs to be called after use because some implementations need to clean up their resources.
    `Map<String,​ConstraintMatchTotal>` | `getConstraintMatchTotalMap()` | Explains the `Score` of `ScoreDirector.calculateScore()` by splitting it up per `Constraint`.
    `Collection<ConstraintMatchTotal>` | `getConstraintMatchTotals()` | Explains the `Score` of `ScoreDirector.calculateScore()` by splitting it up per `Constraint`.
    `Map<Object,​Indictment>` | `getIndictmentMap()` | Explains the impact of each planning entity or problem fact on the `Score`.
    `org.kie.api.runtime.KieSession` | `getKieSession()` |
    `Collection<Object>` | `getWorkingFacts()` |
    `boolean` | `isConstraintMatchEnabled()` |
    `void` | `setWorkingSolution​(Solution_ workingSolution)` | The `working solution` must never be the same instance as the `best solution`, it should be a (un)changed clone.

    - ### Methods inherited from class org.optaplanner.core.impl.score.director.AbstractScoreDirector

      `afterEntityAdded, afterEntityRemoved, afterVariableChanged, assertExpectedUndoMoveScore, assertExpectedWorkingScore, assertPredictedScoreFromScratch, assertShadowVariablesAreNotStale, assertWorkingScoreFromScratch, beforeEntityAdded, beforeEntityAdded, beforeEntityRemoved, beforeEntityRemoved, beforeProblemFactAdded, beforeProblemFactRemoved, beforeProblemPropertyChanged, beforeVariableChanged, beforeVariableChanged, buildScoreCorruptionAnalysis, buildShadowVariableAnalysis, changeVariableFacade, clone, cloneSolution, cloneWorkingSolution, createChildThreadScoreDirector, createShadowVariablesViolationMessage, doAndProcessMove, doAndProcessMove, explainScore, getCalculationCount, getScoreDefinition, getScoreDirectorFactory, getSolutionDescriptor, getSupplyManager, getWorkingEntityCount, getWorkingEntityList, getWorkingEntityListRevision, getWorkingSolution, getWorkingValueCount, isAllChangesWillBeUndoneBeforeStepEnds, isConstraintMatchEnabledPreference, isLookUpEnabled, isWorkingEntityListDirty, lookUpWorkingObject, lookUpWorkingObjectOrReturnNull, overwriteConstraintMatchEnabledPreference, resetCalculationCount, setAllChangesWillBeUndoneBeforeStepEnds, setCalculatedScore, setWorkingEntityListDirty, toString, triggerVariableListeners`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.impl.score.director.ScoreDirector

      `dispose`

- - ### Field Detail

    - #### GLOBAL_SCORE_HOLDER_KEY

          public static final String GLOBAL_SCORE_HOLDER_KEY

      See Also:
        Constant Field Values

    - #### kieSession

          protected org.kie.api.runtime.KieSession kieSession

    - #### scoreHolder

          protected ScoreHolder scoreHolder

  - ### Constructor Detail

    - #### DroolsScoreDirector

          public DroolsScoreDirector​(DroolsScoreDirectorFactory<Solution_> scoreDirectorFactory,
                                     boolean lookUpEnabled,
                                     boolean constraintMatchEnabledPreference)

  - ### Method Detail

    - #### getKieSession

          public org.kie.api.runtime.KieSession getKieSession()

    - #### setWorkingSolution

          public void setWorkingSolution​(Solution_ workingSolution)

      Description copied from interface: `ScoreDirector`
      The `working solution` must never be the same instance as the `best solution`, it should be a (un)changed clone.

      Only call this method on a separate `ScoreDirector` instance, built by `SolverFactory.getScoreDirectorFactory()`, not on the one used inside the `Solver` itself.

      Specified by:
        `setWorkingSolution` in interface `ScoreDirector<Solution_>`
      Overrides:
        `setWorkingSolution` in class `AbstractScoreDirector<Solution_,​DroolsScoreDirectorFactory<Solution_>>`
      Parameters:
        `workingSolution` - never null

    - #### getWorkingFacts

          public Collection<Object> getWorkingFacts()

    - #### calculateScore

          public Score calculateScore()

      Description copied from interface: `ScoreDirector`
      Calculates the `Score` and updates the `working solution` accordingly.
      Returns:
        never null, the `Score` of the `working solution`

    - #### isConstraintMatchEnabled

          public boolean isConstraintMatchEnabled()

      Returns:
        true if `ScoreDirector.getConstraintMatchTotals()`, `ScoreDirector.getConstraintMatchTotalMap()` and `ScoreDirector.getIndictmentMap()` can be called

    - #### getConstraintMatchTotals

          public Collection<ConstraintMatchTotal> getConstraintMatchTotals()

      Description copied from interface: `ScoreDirector`
      Explains the `Score` of `ScoreDirector.calculateScore()` by splitting it up per `Constraint`.

      The sum of `ConstraintMatchTotal.getScore()` equals `ScoreDirector.calculateScore()`.

      Call `ScoreDirector.calculateScore()` before calling this method, unless that method has already been called since the last `PlanningVariable` changes.

      Returns:
        never null
      See Also:
        `ScoreDirector.getConstraintMatchTotalMap()`, `ScoreDirector.getIndictmentMap()`

    - #### getConstraintMatchTotalMap

          public Map<String,​ConstraintMatchTotal> getConstraintMatchTotalMap()

      Description copied from interface: `ScoreDirector`
      Explains the `Score` of `ScoreDirector.calculateScore()` by splitting it up per `Constraint`.

      The sum of `ConstraintMatchTotal.getScore()` equals `ScoreDirector.calculateScore()`.

      Call `ScoreDirector.calculateScore()` before calling this method, unless that method has already been called since the last `PlanningVariable` changes.

      Returns:
        never null, the key is the `constraintId` (to create one, use `ConstraintMatchTotal.composeConstraintId(String, String)`).
      See Also:
        `ScoreDirector.getIndictmentMap()`

    - #### getIndictmentMap

          public Map<Object,​Indictment> getIndictmentMap()

      Description copied from interface: `ScoreDirector`
      Explains the impact of each planning entity or problem fact on the `Score`. An `Indictment` is basically the inverse of a `ConstraintMatchTotal`: it is a `Score` total for each justification `Object` in `ConstraintMatch.getJustificationList()`.

      The sum of `ConstraintMatchTotal.getScore()` differs from `ScoreDirector.calculateScore()` because each `ConstraintMatch.getScore()` is counted for each justification in `ConstraintMatch.getJustificationList()`.

      Call `ScoreDirector.calculateScore()` before calling this method, unless that method has already been called since the last `PlanningVariable` changes.

      Returns:
        never null, the key is a `problem fact` or a `planning entity`
      See Also:
        `ScoreDirector.getConstraintMatchTotalMap()`

    - #### close

          public void close()

      Description copied from interface: `ScoreDirector`
      Needs to be called after use because some implementations need to clean up their resources.
      Specified by:
        `close` in interface `AutoCloseable`
      Specified by:
        `close` in interface `ScoreDirector<Solution_>`
      Overrides:
        `close` in class `AbstractScoreDirector<Solution_,​DroolsScoreDirectorFactory<Solution_>>`

    - #### afterEntityAdded

          public void afterEntityAdded​(EntityDescriptor<Solution_> entityDescriptor,
                                       Object entity)

      Overrides:
        `afterEntityAdded` in class `AbstractScoreDirector<Solution_,​DroolsScoreDirectorFactory<Solution_>>`

    - #### afterVariableChanged

          public void afterVariableChanged​(VariableDescriptor variableDescriptor,
                                           Object entity)

      Specified by:
        `afterVariableChanged` in interface `ScoreDirector<Solution_>`
      Overrides:
        `afterVariableChanged` in class `AbstractScoreDirector<Solution_,​DroolsScoreDirectorFactory<Solution_>>`

    - #### afterEntityRemoved

          public void afterEntityRemoved​(EntityDescriptor<Solution_> entityDescriptor,
                                         Object entity)

      Overrides:
        `afterEntityRemoved` in class `AbstractScoreDirector<Solution_,​DroolsScoreDirectorFactory<Solution_>>`

    - #### afterProblemFactAdded

          public void afterProblemFactAdded​(Object problemFact)

      Specified by:
        `afterProblemFactAdded` in interface `ScoreDirector<Solution_>`
      Overrides:
        `afterProblemFactAdded` in class `AbstractScoreDirector<Solution_,​DroolsScoreDirectorFactory<Solution_>>`

    - #### afterProblemPropertyChanged

          public void afterProblemPropertyChanged​(Object problemFactOrEntity)

      Specified by:
        `afterProblemPropertyChanged` in interface `ScoreDirector<Solution_>`
      Overrides:
        `afterProblemPropertyChanged` in class `AbstractScoreDirector<Solution_,​DroolsScoreDirectorFactory<Solution_>>`

    - #### afterProblemFactRemoved

          public void afterProblemFactRemoved​(Object problemFact)

      Specified by:
        `afterProblemFactRemoved` in interface `ScoreDirector<Solution_>`
      Overrides:
        `afterProblemFactRemoved` in class `AbstractScoreDirector<Solution_,​DroolsScoreDirectorFactory<Solution_>>`